﻿if (app.documents.length != 0){
	if (app.selection.length == 1){
		switch (app.selection[0].constructor.name){
			case "Text":
			case "InsertionPoint":
			case "Character":
			case "Word":
			case "Line":
			case "TextStyleRange":
			case "Paragraph":
				main();
				break;
			default:
				alert("Es ist kein Text markiert.");
				break;
		}
	}
	else{
		alert("Es ist nichts markiert.");
	}
}
else{
	alert("Es ist kein Dokument offen.");
}

function main() {
	var prevHUnits = app.activeDocument.viewPreferences.horizontalMeasurementUnits;
	app.activeDocument.viewPreferences.horizontalMeasurementUnits = MeasurementUnits.points;
	var prevVUnits = app.activeDocument.viewPreferences.verticalMeasurementUnits;
	app.activeDocument.viewPreferences.verticalMeasurementUnits = MeasurementUnits.points;
	
	var aStory = app.selection[0].parentStory;
	var anIX = app.selection[0].index;
	aStory.insertionPoints[anIX].contents = "H";;
	var aChar = aStory.characters[anIX];
	var aSize = aChar.pointSize;
	var aPath = aChar.createOutlines();
	var bSize = aPath[0].geometricBounds[2]-aPath[0].geometricBounds[0];
	aPath[0].remove();
	var aRel = aSize / bSize;
	
	var myDialog = app.dialogs.add({name:"Versalhöhe eingeben"});
	with(myDialog.dialogColumns.add()){
		var vHeightField = measurementEditboxes.add({editValue:(bSize), editUnits:MeasurementUnits.points, smallNudge:0.5});
	}
	var myResult = myDialog.show();
	if(myResult == true){
		var vHeight = vHeightField.editValue;
		myDialog.destroy();
	}
	else{
		myDialog.destroy();
	}
	
	app.selection[0].pointSize = vHeight * aRel;
	
	app.activeDocument.viewPreferences.horizontalMeasurementUnits = prevHUnits;
	app.activeDocument.viewPreferences.verticalMeasurementUnits = prevVUnits;	
}